﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;
using System.Runtime.InteropServices;
using System;

using UnityEngine.UI;

public class ManageColors : MonoBehaviour {

    //Declare GameObject to show key pulsed in screen
    public Text texto;

    //Declare data struct for CIE XYZ tristimulus value
    public struct CIEXYZ{
		public double x,y,z;
	}

    //Declare new variables of type CIE XYZ
	CIEXYZ [] NewTextureXYZArray;
    CIEXYZ xyz;

    //Declare TextAsset variable for .csv files

    //For color matching functions xbar, ybar zbar
    public TextAsset csvFileCMF;
	//For spectra of 4 light suorces
	public TextAsset csvFileLight1;
	public TextAsset csvFileLight2;
	public TextAsset csvFileLight3;
	public TextAsset csvFileLight4;

	
	//arrays xbar, ybar zbar
	float [] X;
	float [] Y;
	float [] Z;

	//arrays SpotLights
	float [] LightSpectrum;

    //Declare width and height variable for texture image dimension
    int width, height;

    double []CalculatedXTrisArray;
	double []CalculatedYTrisArray;
	double []CalculatedZTrisArray;


	//arrays 
	float [] Xluz1;
	float [] Yluz1;
	float [] Zluz1;


	int extension = 380;
	int cont;
	TextAsset OneChannelImage;
	byte[] bytes;
	int TextureSize;

	Texture2D ImageTexture,textaux;
	//array for the sums LightSpectrum

	float [] Tristimulus;//of 12 positions, 3 per each LightSpectrum to evaluate

    string[] records;
    
    //Declare two variables for RGB 8 bits values
	byte [] rgb;
	byte [] rgb2;

	double [] RGB_Light_Source, TextureRGBarray, TextureRGBsinglePixel;
  
	//************* Scene variables **********************
	private Color CalculatedColor;
    private GameObject SpotLights;
	private GameObject LightBooth;

	//Plane for the texture
	public GameObject plano;
    string Light_Source_Name;
    int PressedKey;

	// Use this for initialization
	void Start () {

		//Initialize rgb variable
		rgb = new byte[3];

        //Initialize xyz variable as 0 float
		xyz.x = 0f;
		xyz.y = 0f;
		xyz.z = 0f;

        //Initialize width and height variables
		width = 1;
		height = 1;

        //Initialize X,Y,Z arrays as float for 101 spectral values (380-780 step 4nm) 
        X = new float[101];
		Y= new float[101];
		Z =new float[101];
		
		//arrays para las SpotLights
		LightSpectrum= new float[101];

		Tristimulus = new float[12];

		//inicializamos todo a 0.0
		for (int i = 0; i < 12; i++) {
			Tristimulus [i] = 0.0f;
		}

		//Initialize the color variable CalculatedColor for SpotLights at maximun values (Range 0.0-1.0 float)
        //This RGB value correspond to XYZ White Point of display (Tipically D65)
		CalculatedColor.r = 255 / 255f;
		CalculatedColor.g = 255 / 255f;
		CalculatedColor.b = 255 / 255f;

        //Find GameObject named "Directonal Light" in 3D scene
        LightBooth = GameObject.Find("Directional Light");
		
        //Associate RGB CalculatedColor to SpotLights inside LightBooth
		SpotLights = LightBooth.transform.gameObject;
		SpotLights.GetComponent<Light>().color = CalculatedColor;
		
	    // esta parte es de las imagenes 
        Xluz1 = new float[101];
		Yluz1 = new float[101];
		Zluz1 = new float[101];

        //Calculate size of Image Texture associate to 3D object
        //Unity has pre-defined square sizes of maximum size of 4096*4096
		TextureSize = 4096 * 4096;//+1078;

		CalculatedXTrisArray = new double[TextureSize];
		CalculatedYTrisArray = new double[TextureSize];
		CalculatedZTrisArray = new double[TextureSize];

		rgb2 = new byte[TextureSize*3];

		TextureRGBarray = new double[TextureSize*3];

	}

    // Update is called once per frame
    void Update()
    {

        //****      Fuente1   **************
        //Luz Tl840
        if (Input.GetKeyDown("1"))
        {
            PressedKey = 1;
            float factor = 0.85f;
            Light_Source_Name = "Iluminante D65";
            OneLevelManagement(csvFileLight1, factor, Light_Source_Name, PressedKey);

        }
        else if (Input.GetKeyDown("2")) //Luz D50 Fuente 2
        {
            PressedKey = 2;
            float factor = 0.85f;
            Light_Source_Name = "Luz D65 Cabina";
            OneLevelManagement(csvFileLight2, factor, Light_Source_Name, PressedKey);

        }
        else if (Input.GetKeyDown("3")) //Luz A Fuente 3
        {
            PressedKey = 3;
            float factor = 0.85f;
            Light_Source_Name = "Luz D65 Dos Picos";
            OneLevelManagement(csvFileLight3, factor, Light_Source_Name, PressedKey);
        }
        else if (Input.GetKeyDown("4"))
        {
            PressedKey = 4;
            float factor = 0.85f;
            Light_Source_Name = "Ilu D50";
            OneLevelManagement(csvFileLight4, factor, Light_Source_Name, PressedKey);
        }
        //A partir de este else se Calcula LightSpectrum y texturas
        else if (Input.GetKeyDown("5")) 
        {  

            PressedKey = 5;
            Light_Source_Name = "Iluminante D65";
            float fac = 0.85f;    
            TwoLevelsManagement(csvFileLight1, fac, Light_Source_Name, PressedKey);
        }
        else if (Input.GetKeyDown("6"))
        {   
           
            PressedKey = 6;
            Light_Source_Name = "Simulador Cabina D65";
            float fac = 0.85f; //factor de pedro
            TwoLevelsManagement(csvFileLight2, fac, Light_Source_Name, PressedKey);
        }
        else if (Input.GetKeyDown("7"))
        {   
            //Luz A Fuente 3
            PressedKey = 7;
            Light_Source_Name = "Dos picos";
            float fac = 0.85f; //factor de pedro
            TwoLevelsManagement(csvFileLight3, fac, Light_Source_Name, PressedKey);
        }
        else if (Input.GetKeyDown("8"))
        {   
            //Luz Fuente 4
            PressedKey = 8;
            Light_Source_Name = "ilu D50";
            float fac = 0.85f; //factor de pedro
            TwoLevelsManagement(csvFileLight4, fac, Light_Source_Name, PressedKey);
        }

    }
   

    public void TwoLevelsManagement (TextAsset CVSfile, float factor,string LightSourceName, int Key)
	{

        extension = 380;
        ImportCSVvalues1 (CVSfile,ref LightSpectrum);
		CalculateTristimulus (LightSpectrum, X, ref Tristimulus [0]);
		CalculateTristimulus (LightSpectrum, Y, ref Tristimulus [1]);
		CalculateTristimulus (LightSpectrum, Z, ref Tristimulus [2]);

		//Normalizo dividiendo por Y
		Tristimulus [0] = Tristimulus [0] / Tristimulus [1];
		Tristimulus [2] = Tristimulus [2] / Tristimulus [1];
		Tristimulus [1] = Tristimulus [1] / Tristimulus [1];

		xyz.x = (double) (Tristimulus[0]);
		xyz.y = (double) (Tristimulus[1]);
		xyz.z = (double) (Tristimulus[2]);

		RGB_Light_Source = new double[3];

		xyz.x = xyz.x * factor;
		xyz.y = xyz.y * factor;
		xyz.z = xyz.z * factor;

		XYZ2RGB(xyz.x, xyz.y, xyz.z, ref RGB_Light_Source);


		//este código seria comun a todas las SpotLights
		CalculatedColor.r = (float)RGB_Light_Source[0] / 255f;
 
        CalculatedColor.g = (float)RGB_Light_Source[1] / 255f;
  
        CalculatedColor.b = (float)RGB_Light_Source[2] / 255f;

        SpotLights.GetComponent<Light>().color = CalculatedColor;

		//hasta aqui la LightSpectrum

		ImportCSVvalues3 (csvFileCMF, ref X,ref Y,ref Z);

		//tengo 3 nuevos arrays con el producto de la LightSpectrum y x,y,z
		ThreeArraysProduct (LightSpectrum, X, Y, Z, ref Xluz1, ref Yluz1, ref Zluz1);

        // Inicialize XYZ tristimulus values for each pixel of Image Texture
		for (int i = 0; i < TextureSize; i++) {
			CalculatedXTrisArray[i] = 0;
			CalculatedYTrisArray[i] = 0;
			CalculatedZTrisArray[i] = 0;
		}

        //Inicialize Maximum luminance value calculated in Image Texture
		double MaxYvalue = 0;


		int z = 0;

		byte[] bytes;

		indice = 0;//indice para la OneChannelImage 380

		// Hyperspectral texture procedure
        //Loop for each spectral channel from 380 to 780 nm in steps of 4 nm
        //Each channel is divided in a binary file in TIF format
		for (int j = 0;j<101;j++)
		{
			//cargamos la imagen a tratar
			OneChannelImage = Resources.Load("TexturaCCexcel" + extension) as TextAsset;

			bytes = OneChannelImage.bytes;

			//Bucle para recorrer todos los pixeles de cada OneChannelImage, multiplicarlos por el indice de la LightSpectrum que le corresponda
			for (int i = 1078; i < bytes.Length; i++) 
			{
				z = i - 1078;//quitamos la cabecera de la OneChannelImage, la primera posicion de z seria la 0
				if (bytes [i] != 0) 
				{

					CalculatedXTrisArray [z] = CalculatedXTrisArray [z] + Xluz1 [indice] * bytes [i]; 
					CalculatedYTrisArray [z] = CalculatedYTrisArray [z] + Yluz1 [indice] * bytes [i];

					//calcular el mayor al finalizar cada OneChannelImage
					if (CalculatedYTrisArray [z] > MaxYvalue) 
					{
						MaxYvalue = CalculatedYTrisArray [z];
					}

					CalculatedZTrisArray [z] = CalculatedZTrisArray [z] + Zluz1 [indice] * bytes [i];
				}
			}

			extension = extension + 4;//tomamos las imagenes de 4 en 4
			indice++;//el indice va de 1 en 1 porque Xluz1, Yluz1 y Zluz1 ya lo he reducido de 
		}

        //Normalize XYZ tristimulus value using maximum luminance value (maximum value obtained froma a spectral difuse pattern
		for (int i = 0; i < TextureSize; i++) 
		{
			CalculatedXTrisArray[i] = CalculatedXTrisArray[i] / MaxYvalue * factor;
			CalculatedYTrisArray[i] = CalculatedYTrisArray[i] / MaxYvalue * factor;
			CalculatedZTrisArray[i] = CalculatedZTrisArray[i] / MaxYvalue * factor;
		}

		//creamos un array de struct x y z
		NewTextureXYZArray = new CIEXYZ[TextureSize];

		for (int i = 0; i < TextureSize; i++) 
		{

			NewTextureXYZArray[i].x = CalculatedXTrisArray[i];
			NewTextureXYZArray[i].y = CalculatedYTrisArray[i];
			NewTextureXYZArray[i].z = CalculatedZTrisArray[i];

			XYZ2RGB(NewTextureXYZArray[i].x, NewTextureXYZArray[i].y, NewTextureXYZArray[i].z, ref TextureRGBsinglePixel);

			TextureRGBarray[i*3] = TextureRGBsinglePixel[0];
			TextureRGBarray[i*3+1] = TextureRGBsinglePixel[1];
			TextureRGBarray[i*3+2] = TextureRGBsinglePixel[2];


		}

		//Declare a new Image Texture variable of size 4096x4096
		ImageTexture = new Texture2D (4096, 4096);

		//Initialize Texture Image Array index
		int ind_rgb2 = 0;

		for (int i = 0; i < 4096; i++) {
			for (int j = 0; j < 4096; j++) {

				CalculatedColor.r = (((float)TextureRGBarray[ind_rgb2] / 255f) / ((float)RGB_Light_Source[0] / 255f));

				ind_rgb2++;

				CalculatedColor.g = (((float)TextureRGBarray[ind_rgb2] / 255f) / ((float)RGB_Light_Source[1] / 255f));

				ind_rgb2++;

				CalculatedColor.b = (((float)TextureRGBarray[ind_rgb2] / 255f) / ((float)RGB_Light_Source[2] / 255f));

				ind_rgb2++;
               
				ImageTexture.SetPixel (j,i, CalculatedColor);
			}
		}
		ImageTexture.Apply ();
		plano.GetComponent<Renderer> ().material.mainTexture = ImageTexture;

        Debug.Log("Textura aplicada y finalizada con la LightSpectrum " + LightSourceName+" Vuelva a pulsar 1..8 y Espere mientras se procesan las imagenes ");


    }

    // Function that calculate the RGB 8 bits coodinates for any light source spectrum
    public void OneLevelManagement (TextAsset CSVfile, float factor, string LightSourceName,int Key)
	{
        // Import CSV CVSfile data
		ImportCSVvalues1 (CSVfile,ref LightSpectrum);

		CalculateTristimulus (LightSpectrum, X, ref Tristimulus [0]);
		CalculateTristimulus (LightSpectrum, Y, ref Tristimulus [1]);
		CalculateTristimulus (LightSpectrum, Z, ref Tristimulus [2]);

		//Normalizo dividiendo por Y
		Tristimulus [0] = Tristimulus [0] / Tristimulus [1];
		Tristimulus [2] = Tristimulus [2] / Tristimulus [1];
		Tristimulus [1] = Tristimulus [1] / Tristimulus [1];

		xyz.x = (double) (Tristimulus[0]);
		xyz.y = (double) (Tristimulus[1]);
		xyz.z = (double) (Tristimulus[2]);

		xyz.x = xyz.x * factor;
		xyz.y = xyz.y * factor;
		xyz.z = xyz.z * factor;

		RGB_Light_Source = new double[3];

		XYZ2RGB(xyz.x, xyz.y, xyz.z,ref RGB_Light_Source);

		//este código seria comun a todas las SpotLights 
        // Dividimos por el valor RGB del iluminante D50 del Scanner. Solo se utiliza cuando empleamos objetos con texturas escaneadas.
		CalculatedColor.r = (float)RGB_Light_Source[0] / 255f;
		CalculatedColor.g = (float)RGB_Light_Source[1] / 255f;
		CalculatedColor.b = (float)RGB_Light_Source[2] / 255f;
	

		SpotLights.GetComponent<Light>().color = CalculatedColor;

        Debug.Log("Light Source " + LightSourceName + " applied ");
	
	}


    public void CalculateTristimulus(float[] LightSpectrum, float[] CMF, ref float sum)
    {
        sum = 0.0f;

        for (int i = 0; i < LightSpectrum.Length - 1; i++)
        {
            sum = sum + LightSpectrum[i] * CMF[i];
        }

    }

    //Funtion to read CSV CVSfile with Color Matching Function between 380-780 nm step 1 nm and take values in steps of 4 nm.
    public void ImportCSVvalues3(TextAsset fichero, ref float[] uno, ref float[] dos, ref float[] tres)
    {
        records = fichero.text.Split('\n');
        uno = new float[101];
        dos = new float[101];
        tres = new float[101];
        //Debug.Log ("longitud en leerCSVluces" + records.Length);
        int i = 0;
        int j = 0;
        while (i < records.Length - 1)
        {
            //Debug.Log ("SpotLights " + j+" "+records [i]);
            string[] campos = records[i].Split(';');
            uno[j] = float.Parse(campos[0], System.Globalization.NumberStyles.Float, new System.Globalization.CultureInfo("en-US"));
            dos[j] = float.Parse(campos[1], System.Globalization.NumberStyles.Float, new System.Globalization.CultureInfo("en-US"));
            tres[j] = float.Parse(campos[2], System.Globalization.NumberStyles.Float, new System.Globalization.CultureInfo("en-US"));
            j++;
            i = i + 4;
        }
    }

    //Funtion to read CSV CVSfile with spectrum defined between 380-780 nm step 1 nm and take values in steps of 4 nm.
    public void ImportCSVvalues1(TextAsset fichero, ref float[] uno)
    {
        records = fichero.text.Split('\n');
        uno = new float[101];

        int i = 0;
        int j = 0;
        while (i < records.Length - 1)
        {
            uno[j] = float.Parse(records[i], System.Globalization.NumberStyles.Float, new System.Globalization.CultureInfo("en-US"));
            j++;
            i = i + 4;
        }

    }

    void ThreeArraysProduct(float[] luz, float[] _X, float[] _Y, float[] _Z, ref float[] luzX, ref float[] luzY, ref float[] luzZ)
    {
        for (int i = 0; i < luz.Length; i++)
        {
            luzX[i] = luz[i] * _X[i];
            luzY[i] = luz[i] * _Y[i];
            luzZ[i] = luz[i] * _Z[i];

        }

    }

    // Funtion to transform colors from XYZ to RGB values (0-255)
	void XYZ2RGB(double X, double Y, double Z, ref double[] RGB)
	{
		RGB = new double[3];
		double r, g, b;

        // XYZ2RGB matrix from Chromatic Characterization of Display
		r = 3.2404542 * X - 1.5371385 * Y - 0.4985314 * Z;
		g = (-0.9692660) * X + 1.8760108 * Y + 0.0415560 * Z;
		b = 0.0556434 * X - 0.2040259 * Y + 1.0572252 * Z;

        // Apply gamma transform
		(RGB[0]) = (gamma(r) * 255.0);
		(RGB[1]) = (gamma(g) * 255.0);
		(RGB[2]) = (gamma(b) * 255.0);
	}

    // Funtion to apply gamma transform
	private double gamma(double r)    //sRGB
	{
		double R;
		if (r <= 0.0031308)
			R = 12.92 * r;
		else
			R = Math.Pow(r, 1.0 / 2.4) * 1.055 - 0.055;
		return R;
	}

	


}
